/***************************************************************************
* KeyInfo.CS
*
* Developed by     : RAINBOW SYSTEMS
* Creation Date    : 21-3-2002              
* (C) Copyright 1991-2002 Rainbow Technologies, Inc. All rights reserved.
*
* Purpose     : GetKeyInfo API user input output form.This is Source file for 
				GetKeyInfo Form.

****************************************************************************/

//Include name space
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Sproeval
{
	/// <summary>
	/// GetKeyInfo API user input output form.This is Source file for 
	/// GetKeyInfo Form.
	/// </summary>
	public class KeyInfo : System.Windows.Forms.Form
	{
		// Duffrent resource control declaration here
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button CANCELBtn;
		private System.Windows.Forms.TextBox KeyID;
		private System.Windows.Forms.TextBox HardLimit;
		private System.Windows.Forms.TextBox LicUse;
		private System.Windows.Forms.TextBox NumTimeOut;
		private System.Windows.Forms.TextBox HighUse;

		// Variable for KeyIndex parameter of RNBOsproGetKeyInfo API
		private ushort NextKey=0;
		public const int NSPRO_MONITOR_MAX__BUFFER_SIZE =204 ;
		private System.ComponentModel.Container components = null;

		public KeyInfo()
		{
			//
			// Required for Windows Form Designer support
			// call to initialize diffrent resources in Form.
			//
			InitializeComponent();
		}

		/// <summary>
		// Distroy Form resource at time of closing the form.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(KeyInfo));
			this.CANCELBtn = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.NumTimeOut = new System.Windows.Forms.TextBox();
			this.HighUse = new System.Windows.Forms.TextBox();
			this.HardLimit = new System.Windows.Forms.TextBox();
			this.LicUse = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.KeyID = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// CANCELBtn
			// 
			this.CANCELBtn.Location = new System.Drawing.Point(160, 208);
			this.CANCELBtn.Name = "CANCELBtn";
			this.CANCELBtn.Size = new System.Drawing.Size(75, 25);
			this.CANCELBtn.TabIndex = 11;
			this.CANCELBtn.Text = "&Cancel";
			this.CANCELBtn.Click += new System.EventHandler(this.CANCELBtn_Click);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(32, 208);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(75, 25);
			this.button1.TabIndex = 10;
			this.button1.Text = "&NextKey";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(64, 15);
			this.label2.TabIndex = 2;
			this.label2.Text = "Hard Limit";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 98);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(70, 15);
			this.label3.TabIndex = 4;
			this.label3.Text = "Lic in Use";
			// 
			// NumTimeOut
			// 
			this.NumTimeOut.Location = new System.Drawing.Point(120, 126);
			this.NumTimeOut.MaxLength = 10;
			this.NumTimeOut.Multiline = true;
			this.NumTimeOut.Name = "NumTimeOut";
			this.NumTimeOut.ReadOnly = true;
			this.NumTimeOut.Size = new System.Drawing.Size(144, 23);
			this.NumTimeOut.TabIndex = 7;
			this.NumTimeOut.Text = "";
			// 
			// HighUse
			// 
			this.HighUse.Location = new System.Drawing.Point(120, 160);
			this.HighUse.MaxLength = 10;
			this.HighUse.Multiline = true;
			this.HighUse.Name = "HighUse";
			this.HighUse.ReadOnly = true;
			this.HighUse.Size = new System.Drawing.Size(144, 23);
			this.HighUse.TabIndex = 9;
			this.HighUse.Text = "";
			// 
			// HardLimit
			// 
			this.HardLimit.Location = new System.Drawing.Point(120, 58);
			this.HardLimit.MaxLength = 10;
			this.HardLimit.Multiline = true;
			this.HardLimit.Name = "HardLimit";
			this.HardLimit.ReadOnly = true;
			this.HardLimit.Size = new System.Drawing.Size(144, 23);
			this.HardLimit.TabIndex = 3;
			this.HardLimit.Text = "";
			// 
			// LicUse
			// 
			this.LicUse.Location = new System.Drawing.Point(120, 92);
			this.LicUse.MaxLength = 10;
			this.LicUse.Multiline = true;
			this.LicUse.Name = "LicUse";
			this.LicUse.ReadOnly = true;
			this.LicUse.Size = new System.Drawing.Size(144, 23);
			this.LicUse.TabIndex = 5;
			this.LicUse.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 30);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 15);
			this.label1.TabIndex = 0;
			this.label1.Text = "DevID (Hex)";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 132);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(90, 15);
			this.label4.TabIndex = 6;
			this.label4.Text = "Num Timed Out";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 166);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(90, 15);
			this.label5.TabIndex = 8;
			this.label5.Text = "Highest in Use";
			// 
			// KeyID
			// 
			this.KeyID.Location = new System.Drawing.Point(120, 24);
			this.KeyID.MaxLength = 4;
			this.KeyID.Multiline = true;
			this.KeyID.Name = "KeyID";
			this.KeyID.Size = new System.Drawing.Size(144, 23);
			this.KeyID.TabIndex = 1;
			this.KeyID.Text = "FFFF";
			// 
			// KeyInfo
			// 
			this.AutoScale = false;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(272, 245);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.CANCELBtn,
																		  this.button1,
																		  this.HighUse,
																		  this.label5,
																		  this.NumTimeOut,
																		  this.label4,
																		  this.LicUse,
																		  this.label3,
																		  this.HardLimit,
																		  this.label2,
																		  this.KeyID,
																		  this.label1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "KeyInfo";
			this.Text = "KeyInfo";
			this.Load += new System.EventHandler(this.KeyInfo_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/**************************************************************************
		'* Procedure: button1_Click
		'*
		'* Purpose  : Called on OK button click
		'*
		' Descrip   :Validation for diffrent user inputs.RNBOsproGetKeyInfo API call here.
		'****************************************************************************/		
		private void button1_Click(object sender, System.EventArgs e)
		{
			ushort status = 0;			
			byte[] bKeyBuffer = new byte[NSPRO_MONITOR_MAX__BUFFER_SIZE]; // Buffur for KeyInfo structure
			ushort developerId=0;
			string sdeveloperId="";
			int i_IsValid=-1;
			// Get DevID value entered by user as string
			sdeveloperId=KeyID.Text;
			//Perform validation for DEVID string value and convert into integer.
			i_IsValid = MainForm.isValidData(sdeveloperId.Trim(),MainForm.VALIDDATA_LENGTH,ref developerId);
			
			if(i_IsValid==1) //If DevID is blank
			{
				MessageBox.Show("Specify DeveloperID in input box to proceed.","GetKeyInfo",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
			if(i_IsValid==2)// If DevID string is of invalid length
			{
				MessageBox.Show("DeveloperID must be in hex with length not exceeding 4 digits.","GetKeyInfo");
				return;
			}
			if(i_IsValid==3) // If DevID string is not valid HexString
			{
				MessageBox.Show("DeveloperID must be in hex with length not exceeding 4 digits.","GetKeyInfo");
				return;
			}
			NextKey=(ushort)(NextKey+1); // Increment value by one to get Next KeyInfo 
			
			//**************RNBOsproGetKeyInfo API **********************/
			status = Superpro.RNBOsproGetKeyInfo( Superpro.packet,developerId , NextKey, bKeyBuffer );
			// If API get success
			if (status==0)
			{
				NSPRO_MONITOR_INFO monitorInfo = new NSPRO_MONITOR_INFO();
				//Extract Keyinfo value from KeyInfo structure
				monitorInfo.GetKeyInfo(bKeyBuffer);
				// Display Key info value in output box
				KeyID.Text=Convert.ToString(monitorInfo.sproKeyMonitorInfo.developerId,16);
				HardLimit.Text=Convert.ToString(monitorInfo.sproKeyMonitorInfo.hardLimit,10);
				LicUse.Text=Convert.ToString(monitorInfo.sproKeyMonitorInfo.inUse,10);
				NumTimeOut.Text=Convert.ToString(monitorInfo.sproKeyMonitorInfo.numTimeOut,10);
				HighUse.Text=Convert.ToString(monitorInfo.sproKeyMonitorInfo.highestUse,10);
			}
			//If API get fail
			else
			{
				NextKey=(ushort)(NextKey-1); // decrement value by one)
				MessageBox.Show("GetKeyInfo failed!\n Return code is "+status+".","GetKeyInfo",MessageBoxButtons.OK,MessageBoxIcon.Error);
			}
		}

		/**************************************************************************
		'* Procedure: CANECLBtn_Click
		'*
		'* Purpose  : Called on Cancel button click
		'*
		' Descrip   :Close form and clear output box as blank
		'****************************************************************************/		
		private void CANCELBtn_Click(object sender, System.EventArgs e)
		{
			// assign blank string for diffrent output box
			KeyID.Text="";
			HardLimit.Text="";
			LicUse.Text="";
			NumTimeOut.Text="";
			NumTimeOut.Text="";
			HighUse.Text="";
			//close the form.
			Close ();
		}

		/**************************************************************************
		'* Procedure: KeyInfo_Load
		'*
		'* Purpose  : Called AT TIME OF Form Load
		'*
		' Descrip   :Assign some default value in KeyInfo textBox
		'****************************************************************************/		
		private void KeyInfo_Load(object sender, System.EventArgs e)
		{
		KeyID.Text="FFFF";
		NextKey=0;
		}
	}
}
